/*
 * io.dll
 *
 * Generated from io.dll by winedump.
 *
 * DO NOT SUBMIT GENERATED DLLS FOR INCLUSION INTO WINE!
 *
 */

//#include "config.h"

#include <stdarg.h>
#include <sys/io.h>
#include <stdbool.h>

#include "windef.h"
#include "winbase.h"
#include "io_dll.h"
#include "wine/debug.h"

// Customize this base address if your parallel port is at a nonstandard address
#define LPT_BASE_ADDR			0x378

// These are standard defines that shouldn't need to be changed
#define STANDARD_LPT_BASE_ADDR	0x378
#define LPT_BASE_LEN			4

WINE_DEFAULT_DEBUG_CHANNEL(io);

// Keeps track of whether we successfully initialized the driver
static bool initialized = false;

BOOL WINAPI DllMain(HINSTANCE instance, DWORD reason, LPVOID reserved)
{
	switch (reason)
	{
	case DLL_WINE_PREATTACH:
		return FALSE;    /* prefer native version */
	case DLL_PROCESS_ATTACH:
		// Get permission to use the parallel port
		if (ioperm(LPT_BASE_ADDR, LPT_BASE_LEN, 1) < 0)
		{
			perror("ioperm");
		}
		else
		{
			// As long as we got permission, we're good to go.
			initialized = true;
		}
		DisableThreadLibraryCalls(instance);
		break;
	}
	return TRUE;
}
/******************************************************************
 *		IsDriverInstalled (IO.1)
 *
 *
 */
int __stdcall IO_IsDriverInstalled(void)
{
	return initialized;
}
/******************************************************************
 *		PortIn (IO.11)
 *
 *
 */
char __stdcall IO_PortIn(short Port)
{
	// If we're initialized and it's in the parallel port I/O range,
	// do the read.
	if (initialized &&
		(Port >= STANDARD_LPT_BASE_ADDR) &&
		(Port < STANDARD_LPT_BASE_ADDR + LPT_BASE_LEN))
	{
		return inb(Port - STANDARD_LPT_BASE_ADDR + LPT_BASE_ADDR);
	}
	else
	{
		return 0;
	}
}
/******************************************************************
 *		PortOut (IO.14)
 *
 *
 */
void __stdcall IO_PortOut(short Port, char Data)
{
	// If we're initialized and it's in the parallel port I/O range,
	// do the write.
	if (initialized &&
		(Port >= STANDARD_LPT_BASE_ADDR) &&
		(Port < STANDARD_LPT_BASE_ADDR + LPT_BASE_LEN))
	{
		outb(Data, Port - STANDARD_LPT_BASE_ADDR + LPT_BASE_ADDR);
	}
}
